/* Principiile Programarii Orientate pe Obiecte (POO)
    1. Abstractizare
    2. Incapsulare si Protectia Datelor
    3. Mostenire
    4. Polimorfism
*/

#include <iostream>
#include <string>

class Student {
public:
    // Constructor
    Student()
    {
        name = "";
        age = 0;
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
    Student(std::string name, int age )
    {
        this->name = name;
        this->age = age;
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    Student(std::string name)
    {
        this->name = name;
        age = 0;
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    Student(int age )
    {
        name = "";
        this->age = age;
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
    // Destructor
    ~Student()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
private:
    std::string name;
    int age;
};

int main()
{
    Student s1; // Student()
    Student s11(); // Pitfall (declar o functie, nu un obiect)
    Student s2 ("Ion", 16); // Student (string, int)
    Student s3 ("Ana");  // Student(string)
    Student s4 (16);

    Student s5 {};  // Student()
    Student s6 {"Ion", 16};
    Student s7 {"Ana"};
    Student s8 {16};


    return 0;
}
